# Spline estimation for component function in Generalized Addtive Model
# x: n*p matrix
# y: n*1 vector
# c1,c2: adjust the number of knots for spline
# family: provide a convenient way to specify the details of the models used, same as as glm in R.

gamsplinebic <- function(xfull,y,c1,c2,family,ind) {

library("splines")

x = data.frame(xfull[,ind])
d = ncol(x)
n = nrow(x)
B = array(1,c(n,1))
N = floor(c1*(n^(1/4))*log(n))+2    #number of knots
N = min(N,floor((n/4-1)/d-1))
#N = c1
i = 1
while (i<=d) {
      xi = ecdf(x[,i])(x[,i])
	Bi = bs(xi,knots = min(xi)+(max(xi)-min(xi))*c(1:(N-1))/N,degree = 1)
   	B = cbind(B,Bi)	
	i = i+1
}

Nd = ncol(B)
result = glm(y~B[,2:Nd],family)
lamda = data.matrix(result$coefficients)

#mhat = data.matrix(lamda[1]*B[,1])
#chat = lamda[1]

#i = 1
#while (i<=d) {
#	mhati = B[,((i-1)*N+2):(i*N+1)]%*%lamda[((i-1)*N+2):(i*N+1)]
#	chat = chat + data.matrix(colMeans(mhati))
#	mhat = cbind(mhat,mhati-colMeans(mhati))
#	i = i+1
#}

#mhat[,1] = chat
#thetahat = rowSums(mhat)

thetahat = B%*%lamda

#Computing BIC

LIK = mean(y*thetahat-log(1+exp(thetahat)))
BIC = -LIK+c2*log(n)*ncol(B)/n
return(BIC)

}

