proc(mhat,chat,mhatcubic,chatcubic,biasalpha,Dalpha,v2alpha,falphahat,hoptalpha) = gamsplineh(x,y,c1,c2,alpha)

n = rows(x)  ;sample size n
d = cols(x)

{B0,B1,B2,B3,N} = splineconstruct(x,c1,c2)

B = matrix(n)~reshape(B1[,2:(N+2),],#(n,(N+1)*d))

library("glm")

opt = glmopt("shf",1)

lamda = glmest("bilo",B,y,opt)

lamda = lamda.b

mhat = B1[,2:(N+2),]*reshape(lamda[2:1+(N+1)*d],#((N+1),1,d))
mhat = reshape(mhat,#(n,d))
chat = lamda[1]+sum(mean(mhat),2)
mhat = mhat-mean(mhat)

;estimation of f(x)

xalpha = x[,alpha]
sigmaalphahat = var(xalpha)^(1/2)
halphaf = (8*pi^(1/2)/3)^(1/5)*2.0362*sigmaalphahat*n^(-1/5)*5
kalphaf = 15/16*((1-((xalpha.-xalpha')/halphaf)^2+abs(1-((xalpha.-xalpha')/halphaf)^2))/2)^2/halphaf ;n*n
falphahat = matrix(n);n

;cubic spline of m

Bcubic = matrix(n)~reshape(B3[,2:(N+4),],#(n,(N+3)*d))

lamdacubic = glmest("bilo",Bcubic,y,opt)

lamdacubic = lamdacubic.b

mhatcubic = B3[,2:(N+4),]*reshape(lamdacubic[2:1+(N+3)*d],#((N+3),1,d))
mhatcubic = reshape(mhatcubic,#(n,d))
chatcubic = lamdacubic[1]+sum(mean(mhatcubic),2)
mhatcubic = mhatcubic-mean(mhatcubic)

malphafirst = matrix(n)*lamdacubic[2+(alpha-1)*(N+3)]+B2[,2:(N+3),alpha]*lamdacubic[3+(alpha-1)*(N+3):1+alpha*(N+3)]

malphasecond = matrix(n)*lamdacubic[3+(alpha-1)*(N+3)]+B1[,2:(N+2),alpha]*lamdacubic[4+(alpha-1)*(N+3):1+alpha*(N+3)]


;cubic spline of bderiv2 and bderiv2deriv

thetahatcubic = chatcubic+sum(mhatcubic,2)
bderiv2 = exp(-thetahatcubic)./((1+exp(-thetahatcubic))^2)
bderiv3 = exp(-thetahatcubic).*(exp(-thetahatcubic)-1)./((1+exp(-thetahatcubic))^3)
Bcubicalpha = matrix(n)~reshape(B3[,2:(N+4),alpha],#(n,N+3))
lamdahatalpha2 = inv(Bcubicalpha'*Bcubicalpha)*Bcubicalpha'*bderiv2
bderiv2hat = kalphaf*bderiv2/n
bderiv2derivhat = matrix(n)*lamdahatalpha2[2]+B2[,2:(N+3),alpha]*lamdahatalpha2[3:1+(N+3)]

lamdahatalpha3 = inv(Bcubicalpha'*Bcubicalpha)*Bcubicalpha'*bderiv3
bderiv3hat = Bcubicalpha*lamdahatalpha3
;bderiv3derivhat = matrix(n)*lamdahatalpha3[2]+B2[,2:(N+3),alpha]*lamdahatalpha3[3:1+(N+3)]

yhat = 1/(1+exp(-thetahatcubic))
Dalpha = bderiv2hat

sigma = (y-yhat)^2
v2alpha = kalphaf*sigma*0.7143/n

biasalpha = 0.1429*(malphasecond.*falphahat.*bderiv2hat+malphafirst.*falphahat.*bderiv2derivhat-(malphafirst^2).*falphahat.*bderiv3hat)


;Computing Bandwidth

numalpha = (Dalpha^(-2)).*v2alpha.*falphahat
denoalpha = (biasalpha/Dalpha)^2.*falphahat*4
hoptalpha = (sum(numalpha)/(sum(denoalpha))/n)^(1/5)
 
endp


